/*
*	WGPrefOtrDontDownloadTableDataSource.m
*
*  Copyright (c) 2001 Tomonori Tomatsu. All rights reserved.
*/
#import "WGPrefOtrDontDownloadTableDataSource.h"

@implementation WGPrefOtrDontDownloadTableDataSource
/*===================================
     
=====================================*/
- (id)init
{
    self = [ super init ];
    
    _dontDownloadTableColumn = nil;
    _dontDownloadTableData = nil;
    
    return self;
}

/*===================================
    awakeFromNib
=====================================*/
-(void)awakeFromNib
{
    NSArray*    	theArray;

    // ColumńAPȂ̂ŁALLłႤB 
    theArray = [ _dontDownloadTableView tableColumns ];
    _dontDownloadTableColumn = [ theArray objectAtIndex : 0 ];
    [ _dontDownloadTableColumn retain ];
    
    _dontDownloadTableData = [ [ NSMutableArray alloc ] initWithObjects : @"aaaaaa", @"aaaaava",nil ];
}

/*===================================
    dealloc 
=====================================*/
- (void)dealloc
{
    [ _dontDownloadTableData release ];
    [ _dontDownloadTableColumn release ];
    
    [ super dealloc ];
}

/*===================================
    setDontDownloadTableData
=====================================*/
-(void)setDontDownloadTableData : (NSArray*) inData
{
    [ _dontDownloadTableData release ];
    _dontDownloadTableData = nil;
    _dontDownloadTableData = [ [ NSMutableArray alloc ] initWithArray : inData ];

    [ _dontDownloadTableView reloadData ];
}

/*===================================
    dontDownloadTableData
=====================================*/
-(NSArray*)dontDownloadTableData
{
    return _dontDownloadTableData;
}

//-------- Data Source methods ---------//
/*===================================
    numberOfRowsInTableView
=====================================*/
- (int)numberOfRowsInTableView : (NSTableView *)aTableView
{
    if ( !_dontDownloadTableData ) return 1;
    
    return [ _dontDownloadTableData count ] + 1;
}

/*===================================
    tableView
=====================================*/
- (BOOL)tableView : (NSTableView*)tableView acceptDrop : (id<NSDraggingInfo>)info row : (int)row dropOperation : (NSTableViewDropOperation)operation
{
    return NO;
}

/*===================================
    tableView
=====================================*/
- (id)tableView : (NSTableView *)aTableView objectValueForTableColumn : (NSTableColumn *)aTableColumn row : (int)rowIndex
{
    int		theTotalDataIndex = [ _dontDownloadTableData count ] - 1;
    
    if ( !_dontDownloadTableData || theTotalDataIndex < rowIndex ) return @"";
    
    return [ _dontDownloadTableData objectAtIndex : rowIndex ];
	
}

/*===================================
    tableView
=====================================*/
- (void)tableView : (NSTableView *)aTableView setObjectValue : (id)anObject forTableColumn : (NSTableColumn *)aTableColumn row : (int)rowIndex
{
    int		theTotalDataIndex = [ _dontDownloadTableData count ] - 1;

    if ( theTotalDataIndex < rowIndex ) {
	if ( ![ anObject isEqualToString : @"" ] ) [ _dontDownloadTableData addObject : anObject ];
    } else {
	if ( ![ anObject isEqualToString : @"" ] ) {
	    [ _dontDownloadTableData replaceObjectAtIndex : rowIndex withObject : anObject ];
	} else {
	    [ _dontDownloadTableData removeObjectAtIndex : rowIndex ];
	}
    }

    [ _dontDownloadTableView reloadData ];
    
    // lω|XgB 
    [ [ NSNotificationCenter defaultCenter ] postNotificationName : kWGNowDontDownTableChangedNotification
							   object : self
							 userInfo : nil ];
}     

//-------- Delegate methods ---------//

- (BOOL)selectionShouldChangeInTableView : (NSTableView *)aTableView
{
    return YES;
}
- (BOOL)tableView : (NSTableView *)aTableView shouldEditTableColumn : (NSTableColumn *)aTableColumn row : (int)rowIndex
{
    return YES;
}
- (void)tableView : (NSTableView *) aTableViewwillDisplayCell : (id)aCell forTableColumn : (NSTableColumn *)aTableColumn row : (int)rowIndex
{
    [ _dontDownloadTableView tile ];
}
@end
