/*
*	WGPreferenceLogController.h
*
*  Copyright (c) 2001 Tomonori Tomatsu. All rights reserved.
*/
#import <Cocoa/Cocoa.h>
#import "WGPreferenceProtocol.h"
#import "WGPreferenceDefine.h"

@interface WGPreferenceLogController : NSObject <WGPreferenceController>
{
    IBOutlet id 	WGPrefreanceInstance;
    IBOutlet id 	_l_AppendLogFile;
    IBOutlet id 	_l_LogDotStyle;
    IBOutlet id 	_l_LogDotStyle384K;
    IBOutlet id 	_l_LogDotStyle3M;
    IBOutlet id 	_l_LogDotStyle50K;
    IBOutlet id 	_l_LogDotStyle6K;
    IBOutlet id 	_l_LogDotStyleTitle;
    IBOutlet id 	_l_logFileCapacityNum;
    IBOutlet id 	_l_logFileCapacityTitle;
    IBOutlet id 	_l_logFileCapacityUnit;
    IBOutlet id 	_l_LogFileOutputLocation;
    IBOutlet id 	_l_LogFileOutputLocationExplanation;
    IBOutlet id 	_l_LogFileOutputLocationOpen;
    IBOutlet id 	_l_LogFileOutputLocationTitle;
    IBOutlet id 	_l_LogLevel;
    IBOutlet id 	_l_LogLevelMost;
    IBOutlet id 	_l_LogLevelNone;
    IBOutlet id 	_l_LogLevelTitle;
    IBOutlet id 	_l_MakeLogFile;
    IBOutlet id 	_l_OverwriteLogFile;
    
    int			mLogLevelSliderState;
    NSMutableString*	mLogStyleSliderState;
    BOOL		mOutputLogFileCButtonState;
    NSMutableString*	mLogFileTypeRButtonGroupState;
    BOOL		mLogFileOverwriteRButtonState;
    BOOL		mLogFileAppendRButtonState;
    NSMutableString*	mLogFileSaveLocationTextEditState;
    int			mLogFileCapacityTextEditState;

    int			mSavedLogLevelSliderState;
    NSMutableString*	mSavedLogStyleSliderState;
    BOOL		mSavedOutputLogFileCButtonState;
    NSMutableString*	mSavedLogFileTypeRButtonGroupState;
    BOOL		mSavedLogFileOverwriteRButtonState;
    BOOL		mSavedLogFileAppendRButtonState;
    NSMutableString*	mSavedLogFileSaveLocationTextEditState;
    int			mSavedLogFileCapacityTextEditState;

    long		mChangeValueFlag;
#define	kChangeLogLevel			0x00000001
#define	kChangeLogStyle			0x00000002
#define	kChangeOutputLogFile		0x00000004
#define	kChangeLogFileOverwrite		0x00000008
#define	kChangeLogFileAppend		0x00000010
#define	kChangeLogFileSaveLocation	0x00000020
#define	kChangeLogFileCapacity		0x00000040

}

- (id)init;
- (void)dealloc;

- (IBAction)hitLogFileAppendRButton:(id)sender;
- (IBAction)hitLogFileCapacityTextEdit:(id)sender;
- (IBAction)hitLogFileOverwriteRButton:(id)sender;
- (IBAction)hitLogFileSaveLocationTextEdit:(id)sender;
- (IBAction)hitLogLevelSlider:(id)sender;
- (IBAction)hitLogStyleSlider:(id)sender;
- (IBAction)hitOutputLogFileCButton:(id)sender;

- (IBAction)hitLogFileSaveLocationOpenButton:(id)sender;
- (void)saveLogFileLocationOpenPanelDidEnd : (NSOpenPanel *)sheet returnCode : (int)returnCode contextInfo : (void *)contextInfo;

// Ǐ\bh 
- (void)anyItemHit;

@end
