/*
*	WGPreferenceOtherController.m
*
*  Copyright (c) 2001 Tomonori Tomatsu. All rights reserved.
*/
#import "WGPreferenceOtherController.h"

@implementation WGPreferenceOtherController
/*===================================
     
=====================================*/
- (id)init
{
    self = [ super init ];
    
    mChangeValueFlag = 0;
    
    mWindowDidBecomedMain = NO;

    mDontLookupDNSCButtonState = kWGStateButtonOFF;
    mOnlyCheakCButtonState = kWGStateButtonOFF;
    mUseFTPPassiveModeCButtonState = kWGStateButtonOFF;
    mUseProxyCButtonState = kWGStateButtonOFF;
    mProxyIPAdressState = [ [ NSMutableString alloc ] init ];
    mProxyPortState = [ [ NSMutableString alloc ] init ];
    mDontDownloadState = [ [ NSMutableArray alloc ] initWithCapacity : 1 ];

    mSavedDontLookupDNSCButtonState = kWGStateButtonOFF;
    mSavedOnlyCheakCButtonState = kWGStateButtonOFF;
    mSavedUseFTPPassiveModeCButtonState = kWGStateButtonOFF;
    mSavedUseProxyCButtonState = kWGStateButtonOFF;
    mSavedProxyIPAdressState = [ [ NSMutableString alloc ] init ];
    mSavedProxyPortState = [ [ NSMutableString alloc ] init ];
    mSavedDontDownloadState = [ [ NSMutableArray alloc ] initWithCapacity : 1 ];

    [ [ NSNotificationCenter defaultCenter ] addObserver : self 
						selector : @selector( changedDontDownloadTable : ) 
						    name : kWGNowDontDownTableChangedNotification 
						  object : nil ];

    [ [ NSNotificationCenter defaultCenter ] addObserver : self 
						selector : @selector( windowDidBecomeMain : ) 
						    name : NSWindowDidBecomeKeyNotification 
						  object : nil ];

    return self;
}

/*===================================
    dealloc 
=====================================*/
- (void)dealloc
{
    [ mProxyIPAdressState release ];
    [ mProxyPortState release ];
    [ mDontDownloadState release ];
    [ mSavedProxyIPAdressState release ];
    [ mSavedProxyPortState release ];
    [ mSavedDontDownloadState release ];
 
    [ [ NSNotificationCenter defaultCenter ] removeObserver : self ];
   
    [ super dealloc ];
}

/*===================================
    GUI\̏ 
=====================================*/
- (void)initValuesWithDictionary : (NSMutableDictionary*)values
{
    mChangeValueFlag = 0;

    mSavedDontLookupDNSCButtonState = [ [ values objectForKey : kPreference_o_DNSLookUpKey ] boolValue ];
    mSavedOnlyCheakCButtonState = [ [ values objectForKey : kPreference_o_OnlyCheakKey ] boolValue ];
    mSavedUseFTPPassiveModeCButtonState = [ [ values objectForKey : kPreference_o_UsePassiveModeKey ] boolValue ];
    mSavedUseProxyCButtonState = [ [ values objectForKey : kPreference_o_UseProxyKey ] boolValue ];
    [ mSavedProxyIPAdressState setString : [ values objectForKey : kPreference_o_ProxyIPAdressKey ] ];
    [ mSavedProxyPortState setString : [ values objectForKey : kPreference_o_ProxyPortKey ] ];
    [ mSavedDontDownloadState setArray : [ values objectForKey : kPreference_o_DontGetArrayKey ] ];

    [ self setValuesWithDictionary : values ];
}

/*===================================
    GUIɐݒ肷  
=====================================*/
- (void)setValuesWithDictionary : values
{
    mDontLookupDNSCButtonState = [ [ values objectForKey : kPreference_o_DNSLookUpKey ] boolValue ];
    mOnlyCheakCButtonState = [ [ values objectForKey : kPreference_o_OnlyCheakKey ] boolValue ];
    mUseFTPPassiveModeCButtonState = [ [ values objectForKey : kPreference_o_UsePassiveModeKey ] boolValue ];
    mUseProxyCButtonState = [ [ values objectForKey : kPreference_o_UseProxyKey ] boolValue ];
    [ mProxyIPAdressState setString : [ values objectForKey : kPreference_o_ProxyIPAdressKey ] ];
    [ mProxyPortState setString : [ values objectForKey : kPreference_o_ProxyPortKey ] ];
   [ mDontDownloadState setArray : [ values objectForKey : kPreference_o_DontGetArrayKey ] ];
    // DNSbNAbvȂ  
    if ( kWGStateButtonON == mDontLookupDNSCButtonState ) {
	[ _o_DontLookUpDNS setState : NSOnState ];
    } else {
	[ _o_DontLookUpDNS setState : NSOffState ];
    }
    // `FbNs  
    if ( kWGStateButtonON == mOnlyCheakCButtonState ) {
	[ _o_OnlyCheak setState : NSOnState ];
    } else {
	[ _o_OnlyCheak setState : NSOffState ];
    }
    // Ot@Cɏo͂  
    if ( kWGStateButtonON == mUseFTPPassiveModeCButtonState ) {
	[ _o_UseFtpPassiveMode setState : NSOnState ];
    } else {
	[ _o_UseFtpPassiveMode setState : NSOffState ];
    }
    // vNVg  
    if ( kWGStateButtonON == mUseProxyCButtonState ) {
	[ _o_UseProxy setState : NSOnState ];
    } else {
	[ _o_UseProxy setState : NSOffState ];
    }
    // vNVAhX  
    [ _o_ProxyServerAdress setStringValue : mProxyIPAdressState ];		// 0.2
    // vNV|[g  
    [ _o_ProxyServerPort setStringValue : mProxyPortState ];			// 0.2
    // 擾Ώ 
    [ (WGPrefOthrDontDownTableView*)_o_DontDownloadList setDontDownloadTableData : mDontDownloadState ];
}

/*===================================
    LZꂽ̃Zbg   
=====================================*/
- (void)resetValuesWithDictionary : (NSMutableDictionary*)values
{
    mChangeValueFlag = 0;
    [ self setValuesWithDictionary : values ];
} 

/*===================================
    ̐ݒԂ    
=====================================*/
- (NSDictionary*)dictionaryValues
{
    NSDictionary*	theReturn;
    theReturn = [ [ NSDictionary alloc ] initWithObjectsAndKeys :
		    [ NSNumber numberWithBool : mDontLookupDNSCButtonState ], kPreference_o_DNSLookUpKey,
		    [ NSNumber numberWithBool : mOnlyCheakCButtonState ], kPreference_o_OnlyCheakKey,
		    [ NSNumber numberWithBool : mUseFTPPassiveModeCButtonState ], kPreference_o_UsePassiveModeKey,
		    [ NSNumber numberWithBool : mUseProxyCButtonState ], kPreference_o_UseProxyKey,
		    [ NSString stringWithString : mProxyIPAdressState ], kPreference_o_ProxyIPAdressKey,
		    [ NSString stringWithString : mProxyPortState ] , kPreference_o_ProxyPortKey,
		    [ NSArray arrayWithArray : mDontDownloadState ], kPreference_o_DontGetArrayKey,
		    nil ];

    return theReturn;
}

/*===================================
    hitDontLookupDNSCButton     
=====================================*/
- (IBAction)hitDontLookupDNSCButton:(id)sender
{
    if ( [ sender state] == NSOnState ) {
	mDontLookupDNSCButtonState = kWGStateButtonON;
    } else {
	mDontLookupDNSCButtonState = kWGStateButtonOFF;
    }
    
    if ( mDontLookupDNSCButtonState == mSavedDontLookupDNSCButtonState  ) {
	mChangeValueFlag &= ~kChangeDontLookupDNS;
    } else {
	mChangeValueFlag |= kChangeDontLookupDNS;
    }

    [ self anyItemHit ];
}

/*===================================
    hitFTPUsePassiveModeRButton     
=====================================*/
- (IBAction)hitFTPUsePassiveModeRButton:(id)sender
{
    if ( [ sender state] == NSOnState ) {
	mUseFTPPassiveModeCButtonState = kWGStateButtonON;
    } else {
	mUseFTPPassiveModeCButtonState = kWGStateButtonOFF;
    }
    
    if ( mUseFTPPassiveModeCButtonState == mSavedUseFTPPassiveModeCButtonState  ) {
	mChangeValueFlag &= ~kChangeUseFTPPassiveMode;
    } else {
	mChangeValueFlag |= kChangeUseFTPPassiveMode;
    }

    [ self anyItemHit ];
}

/*===================================
    hitOnlyCheakCButton     
=====================================*/
- (IBAction)hitOnlyCheakCButton:(id)sender
{
    if ( [ sender state] == NSOnState ) {
	mOnlyCheakCButtonState = kWGStateButtonON;
    } else {
	mOnlyCheakCButtonState = kWGStateButtonOFF;
    }
    
    if ( mOnlyCheakCButtonState == mSavedOnlyCheakCButtonState  ) {
	mChangeValueFlag &= ~kChangeOnlyCheak;
    } else {
	mChangeValueFlag |= kChangeOnlyCheak;
    }

    [ self anyItemHit ];
}

/*===================================
    hitProxyIPAdressTextEdit     
=====================================*/
- (IBAction)hitProxyIPAdressTextEdit:(id)sender
{
    [ mProxyIPAdressState setString : [ sender stringValue ] ];

    if ( [ mProxyIPAdressState isEqualToString : mSavedProxyIPAdressState ] ) {
	mChangeValueFlag &= ~kChangeProxyIPAdress;
    } else {
	mChangeValueFlag |= kChangeProxyIPAdress;
    }

    [ self anyItemHit ];
}

/*===================================
    hitProxyPortTextEdit     
=====================================*/
- (IBAction)hitProxyPortTextEdit:(id)sender
{
    [ mProxyPortState setString : [ sender stringValue ] ];

    if ( [ mProxyPortState isEqualToString : mSavedProxyPortState ] ) {
	mChangeValueFlag &= ~kChangeProxyPort;
    } else {
	mChangeValueFlag |= kChangeProxyPort;
    }

    [ self anyItemHit ];
}

/*===================================
    hitUseProxyCButton     
=====================================*/
- (IBAction)hitUseProxyCButton:(id)sender
{
    if ( [ sender state] == NSOnState ) {
	mUseProxyCButtonState = kWGStateButtonON;
    } else {
	mUseProxyCButtonState = kWGStateButtonOFF;
    }
    
    if ( mProxyPortState == mSavedProxyPortState  ) {
	mChangeValueFlag &= ~kChangeProxyPort;
    } else {
	mChangeValueFlag |= kChangeProxyPort;
    }

    [ self anyItemHit ];
}

/*===================================
    hitDontDownloadTable     
=====================================*/
- (IBAction)hitDontDownloadTable:(id)sender
{
}

/*===================================
    changedDontDownloadTable     
=====================================*/
- (void)changedDontDownloadTable : (NSNotification *)inNotification
{
    if ( mWindowDidBecomedMain ) {
	[ mDontDownloadState setArray : [ _o_DontDownloadList dontDownloadTableData ] ];
	if ( [ mSavedDontDownloadState isEqualToArray : mDontDownloadState ] ) {
	    mChangeValueFlag &= ~kDontDownload;
	} else {
	    mChangeValueFlag |= kDontDownload;
	}
	[ self anyItemHit ];
    }
}

/*===================================
    windowDidBecomeMain     
=====================================*/
- (void)windowDidBecomeMain : (NSNotification *)inNotification
{
    mWindowDidBecomedMain = YES;	// 1񂾂Ă΂΂悢B 

    [ [ NSNotificationCenter defaultCenter ] removeObserver : self
						       name : NSWindowDidBecomeKeyNotification
						     object : nil ];
}

/*===================================
    anyItemHit     
=====================================*/
- (void)anyItemHit
{
    if ( mChangeValueFlag ) [ WGPrefreanceInstance changeValue : self ];
    else [ WGPrefreanceInstance unchangeValue : self ];
}
@end
