/*
*	WGWindowController.h
*		・windowController
*		・MediatorパターンのMediator(ConcreteMediator)っぽいかしら？ 
*		・WGWetsCmdWrapparとは、Template Methodパターンでやった方がいいのでしょうか？ 
*		・大きいので、分割を検討すべし。 
*
*  Copyright (c) 2001 Tomonori Tomatsu. All rights reserved.
*/
#import <Cocoa/Cocoa.h>

#import "WGWetsCmdWrappar.h"
#import "WGAppDelegate.h"
#import "WGPreference.h"	// For prefernceArgs
#import "WGDocument.h"		// For addMainWindowControlloer

@class WGDocument;

@interface WGWindowController : NSWindowController
{
    IBOutlet id		cnvtToRelatvLinks;
    IBOutlet id		depth;
    IBOutlet id		depthTitle;
    IBOutlet id		followFTP;
    IBOutlet id		getBtn;
    IBOutlet id		log;
    IBOutlet id		logTitle;					// 0.3.0 使用しなくなった。 
    IBOutlet id		mirror;						// 0.3.0 使用しなくなった。 
    IBOutlet id		onlyRelative;
    IBOutlet id		otherArgs;
    IBOutlet id		otherArgsTitle;
    IBOutlet id		overwrite;
    IBOutlet id		overwriteTitle;
    IBOutlet id		continueBtn;
    IBOutlet id		ow_NoClobber;
    IBOutlet id		ow_UseTimeStamp;
    IBOutlet id		quota;
    IBOutlet id		quotaTitle;
    IBOutlet id		quota_StrMB;
    IBOutlet id		recursive;
    IBOutlet id		recursiveSettingTitle;		// 0.3.0 使用しなくなった。 
    IBOutlet id		spanHost;
    IBOutlet id		url;
    IBOutlet id		mWgetWrapper;
    IBOutlet id		mWGPreference;
    IBOutlet id		mWGDocument;

    NSMutableArray*	mArgs;
    NSTextView*		mLogTextView;
    BOOL		mNowDownloading;
}

- (id)init;
- (void)dealloc;

// IBAction
- (IBAction)downloadAction : (id)sender;
- (IBAction)mirrorAction : (id)sender;
- (IBAction)recursiveAction : (id)sender;

// WGWetsCmdWrapparに対しての口 
- (void)getResponseWithString : (NSString*)inStdErr;
- (void)getResponseWithTerminationStatus : (int)inTerminationStatus;

// WGDocumentに対しての口
- (BOOL)windowShouldClose : (NSWindow*)sender;
- (void)printlog:(id)sender;
//- (void)openLocation : (NSString*)path;

// Notification
- (void)openLocation : (NSNotification *)inNotification;

// 局所メソッド 
- (void)startDownload;
- (void)stopDownload;
- (void)didEndShouldCloseSheetStopDownload : (NSWindow*)sheet returnCode : (int)returnCode contextInfo : (void*)contextInfo;
- (void)didEndShouldCloseSheetCanCloseWindow : (NSWindow*)sheet returnCode : (int)returnCode contextInfo : (void*)contextInfo;
- (void)setupArgs;

@end
